/*
 * Copyright (c) 2005 Your Corporation. All Rights Reserved.
 */
package org.activemq.transport.stomp;

import java.util.Properties;
import java.util.Iterator;

class FrameBuilder
{
    private String command;
    private Properties headers = new Properties();
    private String body = "";

    FrameBuilder(String command)
    {
        this.command = command;
    }

    FrameBuilder addHeader(String key, String value)
    {
        this.headers.setProperty(key, value);
        return this;
    }

    FrameBuilder setBody(String body)
    {
        this.body = body;
        return this;
    }

    public String toString()
    {
        StringBuffer buffer = new StringBuffer();
        buffer.append(command);
        buffer.append(Stomp.NEWLINE);
        for (Iterator iterator = headers.keySet().iterator(); iterator.hasNext();)
        {
            String key = (String) iterator.next();
            buffer.append(key)
                    .append(Stomp.Headers.SEPERATOR)
                    .append(headers.getProperty(key))
                    .append(Stomp.NEWLINE);
        }
        buffer.append(Stomp.NEWLINE);
        buffer.append(body);
        buffer.append(Stomp.NULL);
        buffer.append(Stomp.NEWLINE);
        return buffer.toString();
    }

    String toFrame()
    {
        return toString();
    }
}
