/**
 * Marshalling code for Open Wire Format for ActiveMQMessage
 *
 *
 * NOTE!: This file is autogenerated - do not modify!
 *        if you need to make a change, please see the Groovy scripts in the
 *        activemq-openwire module
 */

package org.activemq.transport.openwire.io;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

import org.activemq.message.*;
import org.activemq.io.*;
import org.activemq.io.impl.*;
import org.activemq.transport.openwire.OpenWirePacketMarshallerSupport;

/**
 * AUTOGENERATED Marshaller for OpenWire command ActiveMQMessage
 *
 * @version $Revision: 1.1 $
 */
public class ActiveMQMessageMarshaller extends OpenWirePacketMarshallerSupport {

    /**
     * Return the type of Packet
     *
     * @return integer representation of the type of Packet
     */
    public int getPacketType() {
        return 16;
    }

    /**
     * @return a new Packet instance
     */
    public Packet createPacket() {
        return new ActiveMQMessage();
    }

    /**
     * build a Packet instance from the data input stream
     *
     * @param packet A Packet object
     * @param dataIn the data input stream to build the packet from
     * @throws IOException
     */
    public void buildPacket(Packet packet, DataInput dataIn) throws IOException {
        super.buildPacket(packet, dataIn);
        ActiveMQMessage info = (ActiveMQMessage) packet;
        info.setConsumerNosAsString(readString(dataIn));
        info.setJMSMessageID(readString(dataIn));
        info.setJMSTimestamp(dataIn.readLong());
        info.setJMSCorrelationID(readString(dataIn));
        info.setJMSReplyTo(readDestination(dataIn));
        info.setJMSDestination(readDestination(dataIn));
        info.setJMSDeliveryMode(dataIn.readInt());
        info.setJMSRedelivered(dataIn.readBoolean());
        info.setJMSType(readString(dataIn));
        info.setJMSExpiration(dataIn.readLong());
        info.setJMSPriority(dataIn.readInt());
        info.setProperties(readProperties(dataIn));
        info.setEntryBrokerName(readString(dataIn));
        info.setEntryClusterName(readString(dataIn));
        info.setJMSClientID(readString(dataIn));
        info.setSequenceNumber(dataIn.readLong());
        info.setDeliveryCount(dataIn.readInt());
        info.setDispatchedFromDLQ(dataIn.readBoolean());
        info.setMesssageHandle(dataIn.readShort());
        info.setExternalMessageId(dataIn.readBoolean());
        info.setProducerKey(readString(dataIn));
        info.setMessagePart(dataIn.readBoolean());
        info.setNumberOfParts(dataIn.readShort());
        info.setPartNumber(dataIn.readShort());
        info.setParentMessageID(readString(dataIn));
        info.setTransactionIDString(readString(dataIn));

    }

    /**
     * Write a Packet instance to data output stream
     *
     * @param packet  the instance to be seralized
     * @param dataOut the output stream
     * @throws IOException thrown if an error occurs
     */
    public void writePacket(Packet packet, DataOutput dataOut) throws IOException {
        super.writePacket(packet, dataOut);
        ActiveMQMessage info = (ActiveMQMessage) packet;
        writeString(info.getConsumerNosAsString(), dataOut);
        writeString(info.getJMSMessageID(), dataOut);
        dataOut.writeLong(info.getJMSTimestamp());
        writeString(info.getJMSCorrelationID(), dataOut);
        writeDestination(info.getJMSReplyTo(), dataOut);
        writeDestination(info.getJMSDestination(), dataOut);
        dataOut.writeInt(info.getJMSDeliveryMode());
        dataOut.writeBoolean(info.getJMSRedelivered());
        writeString(info.getJMSType(), dataOut);
        dataOut.writeLong(info.getJMSExpiration());
        dataOut.writeInt(info.getJMSPriority());
        writeProperties(info.getProperties(), dataOut);
        writeString(info.getEntryBrokerName(), dataOut);
        writeString(info.getEntryClusterName(), dataOut);
        writeString(info.getJMSClientID(), dataOut);
        dataOut.writeLong(info.getSequenceNumber());
        dataOut.writeInt(info.getDeliveryCount());
        dataOut.writeBoolean(info.isDispatchedFromDLQ());
        dataOut.writeShort(info.getMesssageHandle());
        dataOut.writeBoolean(info.isExternalMessageId());
        writeString(info.getProducerKey(), dataOut);
        dataOut.writeBoolean(info.isMessagePart());
        dataOut.writeShort(info.getNumberOfParts());
        dataOut.writeShort(info.getPartNumber());
        writeString(info.getParentMessageID(), dataOut);
        writeString(info.getTransactionIDString(), dataOut);

    }
}
