/**
 * Marshalling code for Open Wire Format for BrokerInfo
 *
 *
 * NOTE!: This file is autogenerated - do not modify!
 *        if you need to make a change, please see the Groovy scripts in the
 *        activemq-openwire module
 */

package org.activemq.transport.openwire.io;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

import org.activemq.message.*;
import org.activemq.io.*;
import org.activemq.io.impl.*;
import org.activemq.transport.openwire.OpenWirePacketMarshallerSupport;

/**
 * AUTOGENERATED Marshaller for OpenWire command BrokerInfo
 *
 * @version $Revision: 1.1 $
 */
public class BrokerInfoMarshaller extends OpenWirePacketMarshallerSupport {

    /**
     * Return the type of Packet
     *
     * @return integer representation of the type of Packet
     */
    public int getPacketType() {
        return 20;
    }

    /**
     * @return a new Packet instance
     */
    public Packet createPacket() {
        return new BrokerInfo();
    }

    /**
     * build a Packet instance from the data input stream
     *
     * @param packet A Packet object
     * @param dataIn the data input stream to build the packet from
     * @throws IOException
     */
    public void buildPacket(Packet packet, DataInput dataIn) throws IOException {
        super.buildPacket(packet, dataIn);
        BrokerInfo info = (BrokerInfo) packet;
        info.setBrokerName(readString(dataIn));
        info.setClusterName(readString(dataIn));
        info.setProperties(readProperties(dataIn));
        info.setStartTime(dataIn.readLong());
        info.setRemote(dataIn.readBoolean());

    }

    /**
     * Write a Packet instance to data output stream
     *
     * @param packet  the instance to be seralized
     * @param dataOut the output stream
     * @throws IOException thrown if an error occurs
     */
    public void writePacket(Packet packet, DataOutput dataOut) throws IOException {
        super.writePacket(packet, dataOut);
        BrokerInfo info = (BrokerInfo) packet;
        writeString(info.getBrokerName(), dataOut);
        writeString(info.getClusterName(), dataOut);
        writeProperties(info.getProperties(), dataOut);
        dataOut.writeLong(info.getStartTime());
        dataOut.writeBoolean(info.isRemote());

    }
}
