/**
 * Marshalling code for Open Wire Format for XATransactionInfo
 *
 *
 * NOTE!: This file is autogenerated - do not modify!
 *        if you need to make a change, please see the Groovy scripts in the
 *        activemq-openwire module
 */

package org.activemq.transport.openwire.io;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

import org.activemq.message.*;
import org.activemq.io.*;
import org.activemq.io.impl.*;
import org.activemq.transport.openwire.OpenWirePacketMarshallerSupport;

/**
 * AUTOGENERATED Marshaller for OpenWire command XATransactionInfo
 *
 * @version $Revision: 1.1 $
 */
public class XATransactionInfoMarshaller extends OpenWirePacketMarshallerSupport {

    /**
     * Return the type of Packet
     *
     * @return integer representation of the type of Packet
     */
    public int getPacketType() {
        return 24;
    }

    /**
     * @return a new Packet instance
     */
    public Packet createPacket() {
        return new XATransactionInfo();
    }

    /**
     * build a Packet instance from the data input stream
     *
     * @param packet A Packet object
     * @param dataIn the data input stream to build the packet from
     * @throws IOException
     */
    public void buildPacket(Packet packet, DataInput dataIn) throws IOException {
        super.buildPacket(packet, dataIn);
        XATransactionInfo info = (XATransactionInfo) packet;
        info.setType(dataIn.readInt());
        info.setXid((org.activemq.message.ActiveMQXid) readObject(dataIn));
        info.setTransactionTimeout(dataIn.readInt());

    }

    /**
     * Write a Packet instance to data output stream
     *
     * @param packet  the instance to be seralized
     * @param dataOut the output stream
     * @throws IOException thrown if an error occurs
     */
    public void writePacket(Packet packet, DataOutput dataOut) throws IOException {
        super.writePacket(packet, dataOut);
        XATransactionInfo info = (XATransactionInfo) packet;
        dataOut.writeInt(info.getType());
        writeObject(info.getXid(), dataOut);
        dataOut.writeInt(info.getTransactionTimeout());

    }
}
